function buildMessageView(msg,align){
	var view = Ti.UI.createView({
		height:Ti.UI.SIZE,
		bottom:0
	})

	var text = Ti.UI.createLabel({
		text:msg,
		color:'white',
		width:'50%',
	})
	if(align == 1) {
		Ti.API.info('LEFT');
		text.left = 0;
		text.textAlign = Ti.UI.TEXT_ALIGNMENT_LEFT;
		text.backgroundColor='rgba(255,0,0,0.5)'
	} else {
		Ti.API.info('RIGHT');
		text.right = 0;
		text.textAlign = Ti.UI.TEXT_ALIGNMENT_RIGHT;
		text.backgroundColor='rgba(0,255,0,0.5)'
	}
	view.add(text);

	var pushC = Ti.UI.iOS.createPushBehavior({pushDirection:{x:0,y:-10},pushMode:Ti.UI.iOS.PUSH_MODE_CONTINUOUS});
	pushC.addItem(view);

	view.pushC = pushC;

	return view;

}

function buildMessage(navWindow)
{
	var win = Ti.UI.createWindow({
	    backgroundColor:'white',
	    title:'MESSAGE',
	    layout:'vertical'
	})

	var textField = Ti.UI.createTextField({
		returnKeyType:Ti.UI.returnKeySend,
		hintText:'Type Here',
		suppressReturn:false,
		font:{fontSize:14},
		borderStyle:Ti.UI.INPUT_BORDERSTYLE_ROUNDED,
		//borderWidth:1,
		width:'80%'
	})

	win.add(textField)

	var scrollView = Ti.UI.createScrollView({
		contentWidth:Ti.UI.FILL
	});

	var refView = Ti.UI.createView();

	scrollView.add(refView);

	win.add(scrollView);

	textField.addEventListener('focus',function(){
		textField.value = '';
	})

	var collision = Ti.UI.iOS.createCollisionBehavior({treatReferenceAsBoundary:true});

	var animator = Ti.UI.iOS.createAnimator({
	    referenceView:refView,
	    behaviors:[collision]
	})

	collision.addEventListener('boundarycollision',function(e){
		scrollView.scrollToBottom();
	});

	collision.addEventListener('itemcollision',function(e){
		scrollView.scrollToBottom();
	});

	var started = false;

	var curHeight = null;
	var refHeight = null;
	var runningHeight = 0;

	function postLayoutListener(e){
		collision.addItem(e.source);
		animator.addBehavior(e.source.pushC);
		e.source.removeEventListener('postlayout',postLayoutListener);
		if(started == false) {
			started = true;
			animator.startAnimator();
		}
		var theH = e.source.size.height;
		runningHeight = runningHeight + theH;
		if (runningHeight > refHeight) {
			curHeight = curHeight + theH;
			refView.height = curHeight;
		}
	}


	align = 1;
	textField.addEventListener('return',function(){
		var message =  textField.value;
		if (message.length == 0) {
			return;
		}
		textField.value = '';
		var v = buildMessageView(message,align);
		align = align * -1;
		if(refHeight == null) {
			curHeight = refView.size.height;
			refHeight = curHeight / 2;
		}
		v.addEventListener('postlayout',postLayoutListener);
		refView.add(v);

	})

	win.addEventListener('blur',function(){
		//In a nav Window this event occurs before the view detaches so this is a 
		//good place to remove behaviors which also stops animator
		animator.removeAllBehaviors();
	})

	navWindow.openWindow(win);

}

module.exports = {
	messageDemo:buildMessage
}

